---
title: DragEvent
slug: Web/API/DragEvent
tags:
  - API
  - DragEvent
  - Reference
  - drag and drop
---
<div>{{APIRef("HTML Drag and Drop API")}}</div>

<p>The <strong><code>DragEvent</code></strong> interface is a {{domxref("Event","DOM event")}} that represents a drag and drop interaction. The user initiates a drag by placing a pointer device (such as a mouse) on the touch surface and then dragging the pointer to a new location (such as another DOM element). Applications are free to interpret a drag and drop interaction in an application-specific way.</p>

<p class="note">This interface inherits properties from {{domxref("MouseEvent")}} and {{domxref("Event")}}.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref('DragEvent.dataTransfer')}} {{readonlyInline}}</dt>
 <dd>The data that is transferred during a drag and drop interaction.</dd>
</dl>

<h2 id="Constructors">Constructors</h2>

<p class="note">Although this interface has a constructor, it is not possible to create a useful DataTransfer object from script, since {{domxref("DataTransfer")}} objects have a processing and security model that is coordinated by the browser during drag-and-drops.</p>

<dl>
 <dt>{{domxref("DragEvent.DragEvent", "DragEvent()")}}</dt>
 <dd>Creates a synthetic and untrusted DragEvent.</dd>
</dl>

<h2 id="Event_types">Event types</h2>

<dl>
 <dt>{{event('drag')}}</dt>
 <dd>This event is fired when an element or text selection is being dragged.</dd>
 <dt>{{event('dragend')}}</dt>
 <dd>This event is fired when a drag operation is being ended (by releasing a mouse button or hitting the escape key).</dd>
 <dt>{{event('dragenter')}}</dt>
 <dd>This event is fired when a dragged element or text selection enters a valid drop target.</dd>
 <dt>{{event('dragexit')}}</dt>
 <dd>This event is fired when an element is no longer the drag operation's immediate selection target.</dd>
 <dt>{{event('dragleave')}}</dt>
 <dd>This event is fired when a dragged element or text selection leaves a valid drop target.</dd>
 <dt>{{event('dragover')}}</dt>
 <dd>This event is fired continuously when an element or text selection is being dragged and the mouse pointer is over a valid drop target (every 50 ms WHEN mouse is not moving ELSE much faster between 5 ms (slow movement) and 1ms (fast movement) approximately. This firing pattern is different than {{Event("mouseover")}} ).</dd>
 <dt>{{event('dragstart')}}</dt>
 <dd>This event is fired when the user starts dragging an element or text selection.</dd>
 <dt>{{event('drop')}}</dt>
 <dd>This event is fired when an element or text selection is dropped on a valid drop target.</dd>
</dl>

<h2 id="GlobalEventHandlers">GlobalEventHandlers</h2>

<dl>
 <dt>{{domxref('GlobalEventHandlers.ondrag')}}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('drag')}} event.</dd>
 <dt>{{domxref('GlobalEventHandlers.ondragend')}}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('dragend')}} event.</dd>
 <dt>{{domxref('GlobalEventHandlers.ondragenter')}}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('dragenter')}} event.</dd>
 <dt>{{domxref('GlobalEventHandlers.ondragexit')}}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('dragexit')}} event.</dd>
 <dt>{{domxref('GlobalEventHandlers.ondragleave')}}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('dragleave')}} event.</dd>
 <dt>{{domxref('GlobalEventHandlers.ondragover')}}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('dragover')}} event.</dd>
 <dt>{{domxref('GlobalEventHandlers.ondragstart')}}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('dragstart')}} event.</dd>
 <dt>{{domxref('GlobalEventHandlers.ondrop')}}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('drop')}} event.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>An Example of each property, constructor, event type and global event handlers is included in their respective reference page.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "#dragevent", "DragEvent")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5.1", "editing.html#the-dragevent-interface", "DragEvent")}}</td>
   <td>{{Spec2("HTML5.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DragEvent")}}</p>

<h2 id="See_also">See also</h2>

<p>{{page("/en-US/docs/Web/API/DataTransfer", "See also")}}</p>
